             .title        "SFEXPROM Reader Plugin"

;07/10/06 
;Written by BootGod
;This is specfically for Bases Loaded (USA) PRG0

             ;vectors for standard system calls
send_byte:    .equ 0200h
baton:        .equ 0203h

addr:         .equ 00e0h
addr_lo:      .equ 00e0h
addr_hi:      .equ 00e1h

curbank:      .equ 00e2h
banksleft:    .equ 00e3h

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "NES-SFEXPROM"
             .db " (Bases Loaded PRG0)"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 256 >> 4,0 >> 4
             .db 64 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             lda #04h
             jsr send_byte   ;send byte
             
             lda #080h
             sta 0ffffh      ;reset MMC1

             lda #000h
             jsr wr_mmc0     ;8K CHR, 32K PRG

got_prg:     lda #0
             jsr send_byte
             lda #4
             jsr send_byte  ;send size
             lda #001h
             jsr send_byte

             lda #8
             sta banksleft
             lda #0
             sta curbank

sp_loop1:    lda #0
             sta addr_lo
             tay
             lda #080h
             sta addr_hi

             lda curbank
             jsr wr_mmc3

sp_loop2:    lda addr_hi
             cmp #081h
             bne not8180h
             cpy #080h
             bne not8180h
             lda #05h
             jsr send_byte
             jmp patched

not8180h:    lda (addr),y
             jsr send_byte
patched:     iny
             bne sp_loop2
             jsr baton
             inc addr_hi
             bne sp_loop2
             inc curbank
             inc curbank
             dec banksleft
             bne sp_loop1


got_chr:     lda #0
             jsr send_byte
             lda #1
             jsr send_byte
             lda #02h
             jsr send_byte

             lda #8
             sta banksleft
             lda #0
             sta curbank
             
gc_lp1:      lda curbank
             jsr wr_mmc1
             ldx #020h
             lda #00h
             tay
             sta 2006h
             sta 2006h
             lda 2007h

gc_lp2:      lda 2007h
             jsr send_byte
             iny
             bne gc_lp2
             jsr baton
             dex
             bne gc_lp2
             inc curbank
             inc curbank
             dec banksleft
             bne gc_lp1


done:        lda #00h
             jsr send_byte
             lda #00h
             jsr send_byte
             lda #00h
             jsr send_byte

             rts


wr_mmc0:     sta 09fffh             
             lsr a
             sta 09fffh
             lsr a
             sta 09fffh
             lsr a
             sta 09fffh
             lsr a
             sta 09fffh
             rts
             
wr_mmc1:     pha
             jsr wr_mmc2
             pla
             sta 0bfffh
             lsr a
             sta 0bfffh
             lsr a
             sta 0bfffh
             lsr a
             sta 0bfffh
             lsr a
             sta 0bfffh
             rts
             
wr_mmc2:     sta 0dfffh
             lsr a
             sta 0dfffh
             lsr a
             sta 0dfffh
             lsr a
             sta 0dfffh
             lsr a
             sta 0dfffh
             rts
             
wr_mmc3:     sta 0ffffh             
             lsr a
             sta 0ffffh
             lsr a
             sta 0ffffh
             lsr a
             sta 0ffffh
             lsr a
             sta 0ffffh
             rts

             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end
